//
//  cbAudioController.h
//  CB
//
//  Created by Stanko Juzbasic on 10/9/15.
//  Copyright (c) 2015 Stanko Juzbasic. All rights reserved.
//

#ifndef TPC_MyAudioController_h
#define TPC_MyAudioController_h

#import "TPCircularBuffer.h"
#import "cbuffer.h"
#import "SatRing.h"
#import <AudioToolbox/AudioToolbox.h>
#import <AudioUnit/AudioUnit.h>
#import <dispatch/dispatch.h>

#define idle 0
#define active 1
#define starting 2
#define stopping 3
#define stopped 4

#define sr 0;
#define tp 1;
#define cb 2;



// Declare mSemaphore somewhere it is available to multiple threads
dispatch_semaphore_t mSemaphore;

Float64 R;
int playing;
UInt32 frames;
int32_t availableBytes;
Boolean debug;

@interface cbAudioController : NSObject {
    TPCircularBuffer            buffer; // PUTs data @head, GETs @ tail!!
    cbuf_t                      cbuffer;
    SatRing_t                   sbuffer;
    //UInt32                      fillThreshold;
    AudioComponentInstance      toneUnit;
    Float64                     sampleRate;
    AudioStreamBasicDescription streamFormat;
    Float32                     f; //frequency
    Float32                     phase;
    Float32                     previous_phase_increment;
    UInt32                      frames;
    int                         state;
    int                         T;
}

@property (assign) IBOutlet NSButton *playButton;

@property (assign) IBOutlet NSSlider *freqSlider;

@property (assign) IBOutlet NSButton *transparentButton;

@property (assign) IBOutlet NSSegmentedControl *segmControl;


- (IBAction)playButtonPressed:(NSButton *)sender;

- (IBAction)sliderDragged:(NSSlider *)sender;

- (IBAction)transparentButtonPressed:(NSButton *)sender;

//- (IBAction)bufferButtonPressed:(NSButton *)sender;

- (IBAction)segmControlPressed:(NSSegmentedControl *)sender;

- (void)setup;
- (void)dealloc;
- (void)createToneUnit;

static int checkResultLite(OSStatus error, const char *operation);

- (void) producer: (Boolean)on;
- (void)dproducer: (Boolean)on;
Float32 updateFrequency(float sliderValue);


@end


#endif
